function X = arrondi_matrice(X)
%
% Arrondit les lments d'une matrice infrieurs  EPS ~= 2* 10^-16  0.
%
%  X = arrondi_matrice(X)  renvoie la matrice X aprs arrondissement  zro de
%  ses lments infrieurs  EPS.
%
%  Auteur : E. Ostertag  27 juin 2005  
%

p = size(X,1); q = size(X,2);
for i=1:p,
	for j=1:q,
		if abs(X(i,j)) <= eps,
			X(i,j) = 0;
		end
	end
end